%global base_name  jci
%global short_name commons-%{base_name}
%global namedreltag %{nil}
%global namedversion %{version}%{?namedreltag}

Name:          apache-commons-jci
Version:       1.0
Epoch:         1
Release:       %mkrel 11
Group:         Development/Java
Summary:       Commons Java Compiler Interface
License:       ASL 2.0
URL:           http://commons.apache.org/jci/
Source0:       ftp://ftp.gbnet.net/pub/apache/dist/commons/%{base_name}/source/%{short_name}-%{namedversion}-src.tar.gz
# force ecj 4.x use
Source1:       %{name}-%{namedversion}-depmap
# fix parent relative path
# fix groovy gId and aId
# add org.codehaus.janino commons-compiler
# remove org.codehaus.mojo findbugs-maven-plugin 1.0.0
Patch0:        %{name}-%{namedversion}-fixbuild.patch
# asm 3 test build
Patch1:        %{name}-%{namedversion}-ExtendedDump.patch
Patch2:        %{name}-%{namedversion}-SimpleDump.patch
# fix parent relative path
# remove jetty-maven-plugin
# use tomcat 7.x apis
Patch3:        %{name}-%{namedversion}-examples-pom.patch

Patch4:        %{name}-%{namedversion}-janino26.patch

Patch5:        %{name}-%{namedversion}-ecj4.patch

BuildRequires: java-devel

BuildRequires: maven-local
BuildRequires: maven-antrun-plugin
BuildRequires: maven-plugin-bundle
BuildRequires: maven-plugin-cobertura
BuildRequires: maven-site-plugin
BuildRequires: maven-surefire-provider-junit4

BuildRequires: apache-commons-logging
BuildRequires: apache-commons-io
BuildRequires: ecj >= 3.4.2-13
BuildRequires: groovy
BuildRequires: janino
BuildRequires: rhino

# test deps
BuildRequires: apache-commons-lang
BuildRequires: junit
BuildRequires: objectweb-asm

Requires:      %{name}-core = %epoch:%{version}-%{release}
BuildArch:     noarch

#* javac Commons JCI compiler implementation for the javac compiler (up to JDK 1.5).
#* jsr199 Commons JCI compiler implementation for JDK 1.6 and up.

%description
JCI is a java compiler interface featuring a compiling class loader.
The current implementation supports compilation via the following
compilers:

* eclipse
* groovy
* janino
* rhino

%package core
Summary:       Commons Java Compiler Interface - core

%description core
Commons JCI core interfaces and implementations.

%package fam
Summary:       Commons Java Compiler Interface - FAM

%description fam
Commons JCI FileAlterationMonitor (FAM) to
monitor local file systems and get notified
about changes.

%package javadoc
Summary:       Javadoc for %{name}
Group:         Documentation

%description javadoc
This package contains javadoc for %{name}.

# compilers

%package eclipse
Summary:       Commons Java Compiler Interface - eclipse

%description eclipse
Commons JCI compiler implementation for the eclipse compiler.

%package groovy
Summary:       Commons Java Compiler Interface - groovy

%description groovy
Commons JCI compiler implementation for the groovy compiler.

%package janino
Summary:       Commons Java Compiler Interface - janino

%description janino
Commons JCI compiler implementation for the janino compiler.

%package rhino
Summary:       Commons Java Compiler Interface - rhino

%description rhino
Commons JCI compiler implementation for rhino JavaScript.

%prep
%setup -q -n %{short_name}-%{namedversion}-src
find . -name "*.class" -delete
find . -name "*.jar" -delete

%patch0 -p1
%patch1 -p0
%patch2 -p0
%patch3 -p0
%patch4 -p1
%patch5 -p0

# require old version of jdependency
%pom_disable_module compilers/javac
%pom_disable_module examples

sed -i "s|<maven.compile.source>1.4<|<maven.compile.source>1.5<|" pom.xml
sed -i "s|<maven.compile.target>1.4<|<maven.compile.target>1.5<|" pom.xml

# Fix installation directory      

%mvn_file :%{short_name}-core    %{short_name}/%{short_name}-core
%mvn_file :%{short_name}-fam     %{short_name}/%{short_name}-fam
%mvn_file :%{short_name}-eclipse %{short_name}/%{short_name}-eclipse
%mvn_file :%{short_name}-groovy  %{short_name}/%{short_name}-groovy
%mvn_file :%{short_name}-janino  %{short_name}/%{short_name}-janino
%mvn_file :%{short_name}-rhino   %{short_name}/%{short_name}-rhino

%build

# random tests failures
%mvn_build -s -- -Dmaven.test.failure.ignore=true -Dmaven.local.depmap.file="%{SOURCE1}"

%install
%mvn_install

%files
%dir %{_javadir}/%{short_name}
%{_mavendepmapfragdir}/apache-commons-jci-commons-jci.xml
#%{_mavenpomdir}/JPP.apache-commons-jci-org.apache.commons@commons-jci.pom
%{_mavenpomdir}/JPP.apache-commons-jci-commons-jci.pom
%doc LICENSE.txt NOTICE.txt README.txt TODO.txt

%files core -f .mfiles-%{short_name}-core

%files fam -f .mfiles-%{short_name}-fam

%files javadoc -f .mfiles-javadoc
%doc LICENSE.txt NOTICE.txt

%files eclipse -f .mfiles-%{short_name}-eclipse

%files groovy -f .mfiles-%{short_name}-groovy

%files janino -f .mfiles-%{short_name}-janino

%files rhino -f .mfiles-%{short_name}-rhino



%changelog
* Wed Dec 25 2013 dmorgan <dmorgan> 1:1.0-11.mga4
+ Revision: 560701
- Fix requires ( epoch was missing)

* Tue Oct 22 2013 umeabot <umeabot> 1:1.0-10.mga4
+ Revision: 545649
- Mageia 4 Mass Rebuild

* Wed Oct 16 2013 dmorgan <dmorgan> 1:1.0-9.mga4
+ Revision: 501536
- Build with xmvn

* Tue Jul 09 2013 dmorgan <dmorgan> 1:1.0-7.mga4
+ Revision: 452063
- fix build for new ecj

* Fri Jan 11 2013 umeabot <umeabot> 1:1.0-6.mga3
+ Revision: 345747
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Sun Dec 23 2012 pterjan <pterjan> 1:1.0-5.mga3
+ Revision: 334380
- Add Fedora patch fixing build with ecj4

* Sun Sep 09 2012 dmorgan <dmorgan> 1:1.0-4.mga3
+ Revision: 290742
- Revert to version 1.0 ( sync with fedora)

* Thu Oct 27 2011 gil <gil> 1.1-1.mga2
+ Revision: 158837
- imported package apache-commons-jci

